From eb3cdb7fe592016c9817a5d39a67f6058be3e524 Mon Sep 17 00:00:00 2001
From: Stephen Wang <wstephen@codeaurora.org>
Date: Mon, 29 Jun 2015 12:25:53 -0700
Subject: [PATCH] [nss-gmac] Fix crash when doing module remove

All remove has been done in gmac_exit_network_interfaces(), so
when nss_gmac_remove() gets called, everything is NULL.

Change-Id: Ifb8b76ab7c8936793cba36e278b16cb1e83979db
Signed-off-by: Stephen Wang <wstephen@codeaurora.org>
---
 ipq806x/nss_gmac_ctrl.c | 35 +++++++++++------------------------
 1 file changed, 11 insertions(+), 24 deletions(-)

diff --git a/ipq806x/nss_gmac_ctrl.c b/ipq806x/nss_gmac_ctrl.c
index c33a346..231ccd5 100644
--- a/ipq806x/nss_gmac_ctrl.c
+++ b/ipq806x/nss_gmac_ctrl.c
@@ -1096,30 +1096,10 @@ nss_gmac_attach_fail:
  */
 static int nss_gmac_remove(struct platform_device *pdev)
 {
-	struct net_device *netdev = NULL;
-	struct nss_gmac_dev *gmacdev = NULL;
-
-	gmacdev = ctx.nss_gmac[pdev->id];
-	if (!gmacdev) {
-		pr_info("Invalid GMAC\n");
-		return -EINVAL;
-	}
-
-	netdev = gmacdev->netdev;
-
-	if (!IS_ERR(gmacdev->phydev)) {
-		phy_disconnect(gmacdev->phydev);
-		gmacdev->phydev = NULL;
-	}
-
-#ifdef RUMI_EMULATION_SUPPORT
-	nss_gmac_deinit_mdiobus(gmacdev);
-#endif
-	nss_gmac_detach(gmacdev);
-	unregister_netdev(gmacdev->netdev);
-	free_netdev(gmacdev->netdev);
-	ctx.nss_gmac[pdev->id] = NULL;
-
+	/*
+	 * All remove has been done in nss_gmac_exit_network_interfaces
+	 * Just return success here
+	 */
 	return 0;
 }
 
@@ -1188,6 +1168,13 @@ void nss_gmac_exit_network_interfaces(void)
 	for (i = 0; i < NSS_MAX_GMACS; i++) {
 		gmacdev = ctx.nss_gmac[i];
 		if (gmacdev) {
+			if (!IS_ERR(gmacdev->phydev)) {
+				phy_disconnect(gmacdev->phydev);
+				gmacdev->phydev = NULL;
+			}
+#ifdef RUMI_EMULATION_SUPPORT
+			nss_gmac_deinit_mdiobus(gmacdev);
+#endif
 			unregister_netdev(gmacdev->netdev);
 			free_netdev(gmacdev->netdev);
 			nss_gmac_detach(gmacdev);
-- 
1.8.2

